#include <propeller.h>
#include "nRF24.h"
#include <sys/thread.h>
//#include "cogload.h"
#ifdef __GNUC__
#define INLINE__ static inline
#define Yield__() __asm__ volatile( "" ::: "memory" )
#define PostEffect__(X, Y) __extension__({ int32_t tmp__ = (X); (X) = (Y); tmp__; })
#else
#define INLINE__ static
static int32_t tmp__;
#define PostEffect__(X, Y) (tmp__ = (X), (X) = (Y), tmp__)
#define Yield__()
#define waitcnt(n) _waitcnt(n)
#define locknew() _locknew()
#define lockret(i) _lockret(i)
#define lockset(i) _lockset(i)
#define lockclr(i) _lockclr(i)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif
#define STACK_SIZE 50
static  int32_t    nRF24_Spiwrite(int32_t Byteout);
static  int32_t    nRF24_Setcommand(int32_t Cmd);
static nRF24 thisobj;
static int cog4_stack[STACK_SIZE];
static _thread_state_t thread_data;
static uint8_t dat[] = {
  0x52, 0xe8, 0xbf, 0x64, 0x52, 0xec, 0xbf, 0x68, 0x50, 0xe8, 0xbf, 0x64, 0x50, 0xec, 0xbf, 0x68, 
  0x51, 0xe8, 0xbf, 0x64, 0x51, 0xec, 0xbf, 0x64, 0x58, 0x92, 0x3c, 0x08, 0x58, 0x94, 0xbc, 0x08, 
  0x07, 0x94, 0x7c, 0xec, 0x4a, 0xae, 0xbc, 0xa0, 0x0d, 0xae, 0xfc, 0x80, 0x01, 0xae, 0xfc, 0x84, 
  0x57, 0x00, 0x3c, 0x5c, 0x11, 0x00, 0x7c, 0x5c, 0x1d, 0x00, 0x7c, 0x5c, 0x29, 0x00, 0x7c, 0x5c, 
  0x39, 0x00, 0x7c, 0x5c, 0x53, 0x9a, 0xbc, 0xa2, 0x52, 0xe8, 0xbf, 0x64, 0x50, 0xe8, 0xbf, 0x64, 
  0x55, 0x98, 0xbc, 0x08, 0x08, 0x98, 0xfc, 0x20, 0x01, 0x98, 0xfc, 0x2d, 0x52, 0xe8, 0xbf, 0x70, 
  0x50, 0xe8, 0xbf, 0x68, 0x50, 0xe8, 0xbf, 0x64, 0x16, 0x9a, 0xfc, 0xe4, 0x52, 0xe8, 0xbf, 0x64, 
  0x06, 0x00, 0x7c, 0x5c, 0x53, 0x9a, 0xbc, 0xa0, 0x52, 0xe8, 0xbf, 0x68, 0x50, 0xe8, 0xbf, 0x64, 
  0xf2, 0xa3, 0x3c, 0x61, 0x50, 0xe8, 0xbf, 0x68, 0x01, 0x98, 0xfc, 0x34, 0x50, 0xe8, 0xbf, 0x64, 
  0x20, 0x9a, 0xfc, 0xe4, 0x54, 0x98, 0x3c, 0x08, 0x56, 0x92, 0x3c, 0x08, 0x52, 0xe8, 0xbf, 0x64, 
  0x06, 0x00, 0x7c, 0x5c, 0x5a, 0x9c, 0xbc, 0x08, 0x50, 0xe8, 0xbf, 0x64, 0x52, 0xe8, 0xbf, 0x64, 
  0x59, 0x9e, 0xbc, 0x08, 0x53, 0x9a, 0xbc, 0xa2, 0x4f, 0x98, 0xbc, 0x00, 0x08, 0x98, 0xfc, 0x20, 
  0x01, 0x98, 0xfc, 0x2d, 0x52, 0xe8, 0xbf, 0x70, 0x50, 0xe8, 0xbf, 0x68, 0x50, 0xe8, 0xbf, 0x64, 
  0x30, 0x9a, 0xfc, 0xe4, 0x52, 0xe8, 0xbf, 0x64, 0x01, 0x9e, 0xfc, 0x80, 0x2d, 0x9c, 0xfc, 0xe4, 
  0x06, 0x00, 0x7c, 0x5c, 0x5a, 0x9c, 0xbc, 0x08, 0x52, 0xe8, 0xbf, 0x68, 0x50, 0xe8, 0xbf, 0x64, 
  0x59, 0x9e, 0xbc, 0x08, 0x53, 0x9a, 0xbc, 0xa0, 0xf2, 0xa3, 0x3c, 0x61, 0x50, 0xe8, 0xbf, 0x68, 
  0x01, 0x98, 0xfc, 0x34, 0x50, 0xe8, 0xbf, 0x64, 0x3e, 0x9a, 0xfc, 0xe4, 0x4f, 0x98, 0x3c, 0x00, 
  0x01, 0x9e, 0xfc, 0x80, 0x3d, 0x9c, 0xfc, 0xe4, 0x56, 0x92, 0x3c, 0x08, 0x52, 0xe8, 0xbf, 0x64, 
  0x06, 0x00, 0x7c, 0x5c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
};
int32_t nRF24_Start(int32_t Pointer)
{ 
 
  _start_cog_thread(cog4_stack + STACK_SIZE, nRF24_Configure, Pointer, &thread_data);
  waitcnt(CNT+CLKFREQ/10);
  return 1;
}

int32_t nRF24_Configure(int32_t Packet)
{
  int32_t    Localindex;
  nRF24_Start_spi(Spimiso, Spimosi, Spisck);
  waitcnt(CNT+CLKFREQ/10);
  OUTA &= ~(1<<Spisck);
  OUTA &= ~(1<<Spimosi);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  OUTA &= ~(1<<Spice);
  DIRA = ((DIRA & 0xfdffffff) | 0x2000000);
  DIRA = ((DIRA & 0xfeffffff) | 0x1000000);
  DIRA = ((DIRA & 0xffbfffff) | 0x400000);
  DIRA = ((DIRA & 0xff7fffff) | 0x800000);
  Localindex = 0;
  do {
    thisobj.Rxaddress[Localindex] = Rxaddress_set;
    thisobj.Txaddress[Localindex] = Txaddress_set;
    Localindex = (Localindex + 1);
  } while (Localindex <= 4);
  
  OUTA &= ~(1<<Spice); 
  
  OUTA &= ~(1<<Spicsn);
  nRF24_Spiwrite((W_register + En_aa));
  nRF24_Spiwrite(Aa_set);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  
  OUTA &= ~(1<<Spicsn);
  nRF24_Spiwrite((W_register + Setup_retr));
  nRF24_Spiwrite(Ret_set);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  OUTA &= ~(1<<Spicsn);
  nRF24_Spiwrite((W_register + Setup_aw));
  nRF24_Spiwrite(Aw_set);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  OUTA &= ~(1<<Spicsn);
  nRF24_Spiwrite((W_register + Rf_setup));
  nRF24_Spiwrite(Rf_set);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  OUTA &= ~(1<<Spicsn);
  nRF24_Spiwrite((W_register + Rx_pw_p0));
  nRF24_Spiwrite(Payloadsize);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  OUTA &= ~(1<<Spicsn);
  nRF24_Spiwrite((W_register + Rf_ch));
  nRF24_Spiwrite(Ch_set);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  OUTA &= ~(1<<Spicsn);
  nRF24_Spiwrite((W_register + Rx_addr_p0));
  Localindex = 0;
  do {
    nRF24_Spiwrite(thisobj.Rxaddress[Localindex]);
    Localindex = (Localindex + 1);
  } while (Localindex <= 4);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  OUTA &= ~(1<<Spicsn);
  nRF24_Spiwrite((W_register + Tx_addr));
  Localindex = 0;
  do {
    nRF24_Spiwrite(thisobj.Txaddress[Localindex]);
    Localindex = (Localindex + 1);
  } while (Localindex <= 4);
  
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  OUTA &= ~(1<<Spicsn);
  nRF24_Spiwrite((W_register + Config));
  nRF24_Spiwrite(Config_set);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  
  OUTA = ((OUTA & 0xff7fffff) | 0x800000);
  
  
  while (1) {
  
    nRF24_Transmitstring(Packet);
    waitcnt(((CLKFREQ /50) + CNT));
  }
  return 0;
}

int32_t nRF24_Spiwrite(int32_t Byteout)
{
  nRF24_Shiftout(Byteout);
  return 0;
}

int32_t nRF24_Transmitstring(int32_t Localptr)
{
  
  int32_t    Localindex;
  OUTA &= ~(1<<Spicsn);
  nRF24_Shiftout((W_register + _status));
  nRF24_Shiftout(Nordicstatus);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);

  OUTA &= ~(1<<Spicsn);
  nRF24_Shiftout(Flush_tx);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
  
  OUTA &= ~(1<<Spicsn);
  nRF24_Shiftout(W_tx_payload);
  nRF24_Shiftoutstr(Localptr, Payloadsize);
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);
 
   OUTA &= ~(1<<Spicsn);
  nRF24_Spiwrite((W_register + Tx_addr));
  Localindex = 0;
  do {
    nRF24_Spiwrite(thisobj.Txaddress[Localindex]);
    Localindex = (Localindex + 1);
  } while (Localindex <= 4);
  
  OUTA = ((OUTA & 0xffbfffff) | 0x400000);   
  return 0;
  }

int32_t nRF24_Shiftout(int32_t Value)
{ 
  thisobj.Valueout = Value;
  nRF24_Setcommand(_shiftout);
  return 0;
}

int32_t nRF24_Shiftoutstr(int32_t Localptr, int32_t Bytes)
{
  thisobj.Globalptr = Localptr;
  thisobj.Buffersize = Bytes;
  nRF24_Setcommand(_shiftoutstring);
  return 0;
}

int32_t nRF24_Start_spi(int32_t _miso, int32_t _mosi, int32_t _clock)
{
  int32_t Okay = 0;
  ((int32_t *)&dat[356])[0] = (int32_t)(&thisobj.Globalptr);
  ((int32_t *)&dat[360])[0] = (int32_t)(&thisobj.Buffersize);
  ((int32_t *)&dat[324])[0] = 1;
  ((int32_t *)&dat[328])[0] = 1;
  ((int32_t *)&dat[320])[0] = 1;
  ((int32_t *)&dat[320])[0] = ((*(int32_t *)&dat[320]) << _clock);
  ((int32_t *)&dat[324])[0] = ((*(int32_t *)&dat[324]) << _miso);
  ((int32_t *)&dat[328])[0] = ((*(int32_t *)&dat[328]) << _mosi);
  ((int32_t *)&dat[336])[0] = (int32_t)(&thisobj.Valuein);
  ((int32_t *)&dat[340])[0] = (int32_t)(&thisobj.Valueout);
  ((int32_t *)&dat[344])[0] = (int32_t)(&thisobj.Globalflag);
  ((int32_t *)&dat[352])[0] = (int32_t)(&thisobj.Command);
  //writeToBootEeprom(0, &dat[0], 364);
  //cognewFromBootEeprom(0, 364,&thisobj.Command);
  Okay = (thisobj.Cog = (cognew((int32_t)(&(*(int32_t *)&dat[0])), (int32_t)(&thisobj.Command)) + 1));
  return Okay;
}

int32_t nRF24_Setcommand(int32_t Cmd)
{
  thisobj.Command = Cmd;
  while (thisobj.Command) {
    Yield__();
  }
  return 0;
}

static void high(int WCpin)
{
    unsigned int bits = 1 << WCpin;
    DIRA |= bits;
    OUTA |= bits;
}

/*
 * Set a pin low without affecting other pins.
 * param WCpin = pin number to set low.
 */
static void low(int WCpin)
{
    unsigned int mask = 1 << WCpin;
    DIRA |= mask;
    OUTA &= ~mask;
}